import uuid

from sqlalchemy import Text, Uuid, text
from sqlalchemy.orm import Mapped, mapped_column

from ..db.base_class import reg


@reg.mapped_as_dataclass(unsafe_hash=True)
class Printer:
    __tablename__ = "printers"

    id: Mapped[uuid.UUID] = mapped_column(Uuid, primary_key=True, server_default=text("gen_random_uuid()"))
    name: Mapped[str] = mapped_column(Text, unique=True, nullable=False)
    address: Mapped[str] = mapped_column(Text, nullable=False)
    cut_code: Mapped[str] = mapped_column(Text, nullable=False)

    def __init__(self, name=None, address=None, cut_code=None, id_=None):
        self.id = id_
        self.name = name
        self.address = address
        self.cut_code = cut_code
