import uuid

from typing import TYPE_CHECKING, List

from sqlalchemy import Boolean, Text, Uuid, text
from sqlalchemy.orm import Mapped, mapped_column, relationship

from ..db.base_class import reg


if TYPE_CHECKING:
    from .device import Device


@reg.mapped_as_dataclass(unsafe_hash=True)
class Section:
    __tablename__ = "sections"

    id: Mapped[uuid.UUID] = mapped_column(Uuid, primary_key=True, server_default=text("gen_random_uuid()"))
    name: Mapped[str] = mapped_column(Text, unique=True, nullable=False)
    is_fixture: Mapped[bool] = mapped_column(Boolean, nullable=False, insert_default=False)

    devices: Mapped[List["Device"]] = relationship(back_populates="section")

    def __init__(self, name=None, is_fixture=None, id_=None):
        self.id = id_
        self.name = name
        self.is_fixture = is_fixture

    @classmethod
    def main(cls):
        return uuid.UUID("3f13f6e7-dc76-4fca-8fdb-b2bbf29b35df")
